using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using metadatalibrary;
using Xceed.Grid;

namespace metaeasylibrary
{
	/// <summary>
	/// Summary description for FrmElencoErrori.
	/// </summary>
	public class FrmElencoErrori : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ImageList MyPics;
		private Xceed.Grid.GroupByRow groupByRow1;
		private Xceed.Grid.GroupByRow groupByRow2;
		private Xceed.Grid.GroupByRow groupByRow3;
		private Xceed.Grid.ColumnManagerRow columnManagerRow1;
		private Xceed.Grid.DataRow dataRowTemplate1;
		private Xceed.Grid.VisualGridElementStyle dataRowStyle1;
		private System.Windows.Forms.Label labCheckType;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.PictureBox Disegno;
		private System.Windows.Forms.Button btnAnnulla;
		private System.Windows.Forms.Button btnIgnora;
		private Xceed.Grid.GridControl gridX;
		private System.Windows.Forms.Button btnExcel;
		private System.Windows.Forms.Label label1;
		DataTable Dati;

        static FrmElencoErrori() {
            Licenser.LicenseKey = "GRD11-X4APU-MTZWK-TAJA";
        }

		public FrmElencoErrori(EasyProcedureMessageCollection Msgs)
		{
			//
			// Required for Windows Form Designer support
			//
            Licenser.LicenseKey = "GRD11-X4APU-MTZWK-TAJA";
            InitializeComponent();


			Disegno.Image= MyPics.Images[0];

			if (Msgs.PostMsgs){
				labCheckType.Text="Controlli dopo il tentato salvataggio";
			}
			else {
				labCheckType.Text="Controlli prima del salvataggio";
			}

			if (!Msgs.CanIgnore){
				btnIgnora.Visible=false;
				btnIgnora.Enabled=false;
				//Bitmap BM2 = new Bitmap("bin\\STOP.gif");
				Disegno.Image= MyPics.Images[1];
			}

			DataSet D = new DataSet("Nino");
			DataTable T = new DataTable("errori");
			T.Columns.Add("msg",typeof(string));
			T.Columns["msg"].Caption="Messaggio di errore";
			T.Columns.Add("kind",typeof(string));
			T.Columns["kind"].Caption="Gravit";
			T.Columns.Add("codice",typeof(string));
			T.Columns["codice"].Caption="Codice";
			T.Columns.Add("table",typeof(string));
			T.Columns["table"].Caption="Tabella";
			T.Columns.Add("operation",typeof(string));
			T.Columns["operation"].Caption="Op.";
			T.Columns.Add("id",typeof(string));
			T.Columns["id"].Caption="#";
			D.Tables.Add(T);
			foreach (EasyProcedureMessage CM in Msgs){
				System.Data.DataRow R = T.NewRow();
				R["msg"]=ConvertCarriages(CM.LongMess);
				R["kind"]= CM.ErrorType;
				R["codice"]=CM.AuditID;
				R["table"]=CM.TableName;
				R["operation"]= CM.Operation.Substring(0,1);
				R["id"]=CM.EnforcementNumber.ToString();
				T.Rows.Add(R);
			}

			gridX.BeginInit();
			gridX.SetDataBinding(D, "errori");
			gridX.SortedColumns.Add("kind", false);
			gridX.SortedColumns.Add("codice", true);
			foreach (DataColumn C in T.Columns) 
				gridX.Columns[C.ColumnName].Title = C.Caption;
			gridX.Columns["msg"].Width=450;
			gridX.Columns["kind"].Width=75;
			gridX.Columns["codice"].Width=100;
			gridX.Columns["table"].Width=100;
			gridX.Columns["operation"].Width=30;
			gridX.Columns["id"].Width=30;


			gridX.EndInit();
			Dati= T;


		}

		string ConvertCarriages(string S){
			S = S.Replace("\r","\n");
			S = S.Replace("\n\n","\n");
			S = S.Replace("\n","\r\n");
			return S;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(FrmElencoErrori));
			this.MyPics = new System.Windows.Forms.ImageList(this.components);
			this.Disegno = new System.Windows.Forms.PictureBox();
			this.btnAnnulla = new System.Windows.Forms.Button();
			this.btnIgnora = new System.Windows.Forms.Button();
			this.groupByRow1 = new Xceed.Grid.GroupByRow();
			this.groupByRow2 = new Xceed.Grid.GroupByRow();
			this.gridX = new Xceed.Grid.GridControl();
			this.dataRowTemplate1 = new Xceed.Grid.DataRow();
			this.dataRowStyle1 = new Xceed.Grid.VisualGridElementStyle();
			this.groupByRow3 = new Xceed.Grid.GroupByRow();
			this.columnManagerRow1 = new Xceed.Grid.ColumnManagerRow();
			this.labCheckType = new System.Windows.Forms.Label();
			this.btnExcel = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.gridX)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.dataRowTemplate1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.columnManagerRow1)).BeginInit();
			this.SuspendLayout();
			// 
			// MyPics
			// 
			this.MyPics.ImageSize = new System.Drawing.Size(64, 64);
			this.MyPics.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("MyPics.ImageStream")));
			this.MyPics.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// Disegno
			// 
			this.Disegno.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.Disegno.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.Disegno.Image = ((System.Drawing.Image)(resources.GetObject("Disegno.Image")));
			this.Disegno.Location = new System.Drawing.Point(328, 336);
			this.Disegno.Name = "Disegno";
			this.Disegno.Size = new System.Drawing.Size(80, 72);
			this.Disegno.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.Disegno.TabIndex = 1;
			this.Disegno.TabStop = false;
			// 
			// btnAnnulla
			// 
			this.btnAnnulla.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnAnnulla.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.btnAnnulla.Location = new System.Drawing.Point(104, 360);
			this.btnAnnulla.Name = "btnAnnulla";
			this.btnAnnulla.Size = new System.Drawing.Size(152, 23);
			this.btnAnnulla.TabIndex = 2;
			this.btnAnnulla.Text = "Non salvare";
			this.btnAnnulla.Click += new System.EventHandler(this.btnAnnulla_Click);
			// 
			// btnIgnora
			// 
			this.btnIgnora.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnIgnora.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.btnIgnora.Location = new System.Drawing.Point(448, 360);
			this.btnIgnora.Name = "btnIgnora";
			this.btnIgnora.Size = new System.Drawing.Size(200, 23);
			this.btnIgnora.TabIndex = 3;
			this.btnIgnora.Text = "Ignora i messaggi e salva lo stesso";
			this.btnIgnora.Click += new System.EventHandler(this.btnIgnora_Click);
			// 
			// groupByRow1
			// 
			this.groupByRow1.AllowDrop = true;
			this.groupByRow1.AutoHeightMode = Xceed.Grid.AutoHeightMode.Minimum;
			this.groupByRow1.BackColor = System.Drawing.SystemColors.ControlLight;
			this.groupByRow1.CellBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(102)));
			this.groupByRow1.CellFont = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold);
			this.groupByRow1.NoGroupText = "Trascina qui l\'intestazione di una colonna per formare un raggruppamento";
			this.groupByRow1.Trimming = System.Drawing.StringTrimming.None;
			// 
			// groupByRow2
			// 
			this.groupByRow2.AllowDrop = true;
			this.groupByRow2.AutoHeightMode = Xceed.Grid.AutoHeightMode.Minimum;
			this.groupByRow2.BackColor = System.Drawing.SystemColors.ControlLight;
			this.groupByRow2.CellBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(102)));
			this.groupByRow2.CellFont = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Bold);
			this.groupByRow2.NoGroupText = "Trascina qui l\'intestazione di una colonna per formare un raggruppamento";
			this.groupByRow2.Trimming = System.Drawing.StringTrimming.None;
			// 
			// gridX
			// 
			this.gridX.AllowCellNavigation = false;
			this.gridX.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridX.ClipPartialLine = false;
			this.gridX.DataRowTemplate = this.dataRowTemplate1;
			this.gridX.DataRowTemplateStyles.Add(this.dataRowStyle1);
			this.gridX.FixedHeaderRows.Add(this.groupByRow3);
			this.gridX.FixedHeaderRows.Add(this.columnManagerRow1);
			this.gridX.InactiveSelectionBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(102)));
			this.gridX.InactiveSelectionForeColor = System.Drawing.SystemColors.ControlText;
			this.gridX.Location = new System.Drawing.Point(8, 24);
			this.gridX.Name = "gridX";
			this.gridX.ReadOnly = true;
			// 
			// gridX.RowSelectorPane
			// 
			this.gridX.RowSelectorPane.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(153)), ((System.Byte)(102)));
			this.gridX.SelectionBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(102)));
			this.gridX.SelectionForeColor = System.Drawing.SystemColors.ControlText;
			this.gridX.SelectionMode = System.Windows.Forms.SelectionMode.One;
			this.gridX.Size = new System.Drawing.Size(760, 304);
			this.gridX.TabIndex = 4;
			this.gridX.Trimming = System.Drawing.StringTrimming.None;
			this.gridX.WordWrap = true;
			// 
			// dataRowTemplate1
			// 
			this.dataRowTemplate1.Height = 64;
			// 
			// dataRowStyle1
			// 
			this.dataRowStyle1.ClipPartialLine = false;
			this.dataRowStyle1.Trimming = System.Drawing.StringTrimming.None;
			this.dataRowStyle1.VerticalAlignment = Xceed.Grid.VerticalAlignment.Center;
			this.dataRowStyle1.WordWrap = true;
			// 
			// groupByRow3
			// 
			this.groupByRow3.AutoHeightMode = Xceed.Grid.AutoHeightMode.AllContent;
			this.groupByRow3.CellBackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(102)));
			// 
			// groupByRow3.RowSelector
			// 
			this.groupByRow3.RowSelector.BackColor = System.Drawing.SystemColors.ControlDark;
			this.groupByRow3.Visible = false;
			// 
			// labCheckType
			// 
			this.labCheckType.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labCheckType.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.labCheckType.Location = new System.Drawing.Point(536, 0);
			this.labCheckType.Name = "labCheckType";
			this.labCheckType.Size = new System.Drawing.Size(224, 16);
			this.labCheckType.TabIndex = 5;
			this.labCheckType.Text = "Controlli prima del salvataggio";
			this.labCheckType.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// btnExcel
			// 
			this.btnExcel.Location = new System.Drawing.Point(280, 0);
			this.btnExcel.Name = "btnExcel";
			this.btnExcel.Size = new System.Drawing.Size(208, 23);
			this.btnExcel.TabIndex = 6;
			this.btnExcel.Text = "Esporta l\'elenco degli errori in Excel";
			this.btnExcel.Click += new System.EventHandler(this.btnExcel_Click);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Italic, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.ForeColor = System.Drawing.SystemColors.Desktop;
			this.label1.Location = new System.Drawing.Point(608, 392);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(152, 23);
			this.label1.TabIndex = 7;
			this.label1.Text = "powered by MetaDataLibrary";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// FrmElencoErrori
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(776, 413);
			this.ControlBox = false;
			this.Controls.Add(this.label1);
			this.Controls.Add(this.btnExcel);
			this.Controls.Add(this.labCheckType);
			this.Controls.Add(this.gridX);
			this.Controls.Add(this.btnIgnora);
			this.Controls.Add(this.btnAnnulla);
			this.Controls.Add(this.Disegno);
			this.Name = "FrmElencoErrori";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Elenco errori ed avvertimenti";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.FrmElencoErrori_Closing);
			this.Load += new System.EventHandler(this.FrmElencoErrori_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridX)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.dataRowTemplate1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.columnManagerRow1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		bool CanClose=false;
		private void FrmElencoErrori_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
			e.Cancel=!CanClose;
		}

		private void btnAnnulla_Click(object sender, System.EventArgs e) {
			CanClose=true;
		}

		private void btnIgnora_Click(object sender, System.EventArgs e) {
			CanClose=true;
		}

		private void btnExcel_Click(object sender, System.EventArgs e) {
			if (Dati!=null) 
				exportclass.DataTableToExcel(Dati,true,null,null);
		}

		private void FrmElencoErrori_Load(object sender, System.EventArgs e) {
		
		}
	}
}
